# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from electronic_io_msgs/DigitizedAnalogIOInfo.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import electronic_io_msgs.msg
import genpy

class DigitizedAnalogIOInfo(genpy.Message):
  _md5sum = "2a8387eae5fe0f9976b87b42c4fc8bfc"
  _type = "electronic_io_msgs/DigitizedAnalogIOInfo"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# Metadata of a digitized analog I/O pin (working with ADC values).

IOPinInfo pin  # The I/O pin metadata.
duration sampling_period  # Duration of sampling (inverse of sampling frequency).
                          # If not known, output-only or variable, set to 0.
int64 min_value  # Minimum value that can be read from / written to the pin (usually zero).
int64 max_value  # Maximum value that can be read from / written to the pin. If equal to min_value, there is no limit.

================================================================================
MSG: electronic_io_msgs/IOPinInfo
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# Metadata of a single I/O pin.

string name  # Name of the pin (from SDK, datasheet, package marking etc.)
bool is_readable  # True if the pin value can be read (can also be true for output pins if readback is supported).
bool is_writable  # True if the pin value can be written to (output pins).
bool can_persist  # Whether a writable pin's value can be persisted (i.e. stored in some kind of non-volatile memory)."""
  __slots__ = ['pin','sampling_period','min_value','max_value']
  _slot_types = ['electronic_io_msgs/IOPinInfo','duration','int64','int64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       pin,sampling_period,min_value,max_value

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(DigitizedAnalogIOInfo, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.pin is None:
        self.pin = electronic_io_msgs.msg.IOPinInfo()
      if self.sampling_period is None:
        self.sampling_period = genpy.Duration()
      if self.min_value is None:
        self.min_value = 0
      if self.max_value is None:
        self.max_value = 0
    else:
      self.pin = electronic_io_msgs.msg.IOPinInfo()
      self.sampling_period = genpy.Duration()
      self.min_value = 0
      self.max_value = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.pin.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3B2i2q().pack(_x.pin.is_readable, _x.pin.is_writable, _x.pin.can_persist, _x.sampling_period.secs, _x.sampling_period.nsecs, _x.min_value, _x.max_value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.pin is None:
        self.pin = electronic_io_msgs.msg.IOPinInfo()
      if self.sampling_period is None:
        self.sampling_period = genpy.Duration()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pin.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.pin.name = str[start:end]
      _x = self
      start = end
      end += 27
      (_x.pin.is_readable, _x.pin.is_writable, _x.pin.can_persist, _x.sampling_period.secs, _x.sampling_period.nsecs, _x.min_value, _x.max_value,) = _get_struct_3B2i2q().unpack(str[start:end])
      self.pin.is_readable = bool(self.pin.is_readable)
      self.pin.is_writable = bool(self.pin.is_writable)
      self.pin.can_persist = bool(self.pin.can_persist)
      self.sampling_period.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.pin.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3B2i2q().pack(_x.pin.is_readable, _x.pin.is_writable, _x.pin.can_persist, _x.sampling_period.secs, _x.sampling_period.nsecs, _x.min_value, _x.max_value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.pin is None:
        self.pin = electronic_io_msgs.msg.IOPinInfo()
      if self.sampling_period is None:
        self.sampling_period = genpy.Duration()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pin.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.pin.name = str[start:end]
      _x = self
      start = end
      end += 27
      (_x.pin.is_readable, _x.pin.is_writable, _x.pin.can_persist, _x.sampling_period.secs, _x.sampling_period.nsecs, _x.min_value, _x.max_value,) = _get_struct_3B2i2q().unpack(str[start:end])
      self.pin.is_readable = bool(self.pin.is_readable)
      self.pin.is_writable = bool(self.pin.is_writable)
      self.pin.can_persist = bool(self.pin.can_persist)
      self.sampling_period.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3B2i2q = None
def _get_struct_3B2i2q():
    global _struct_3B2i2q
    if _struct_3B2i2q is None:
        _struct_3B2i2q = struct.Struct("<3B2i2q")
    return _struct_3B2i2q
