# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from electronic_io_msgs/IOInfo.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import electronic_io_msgs.msg
import genpy
import std_msgs.msg

class IOInfo(genpy.Message):
  _md5sum = "8e9ddc7436a29885ebfe415d889e12d7"
  _type = "electronic_io_msgs/IOInfo"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# Metadata of a group of digital or analog I/O pins.
# This message should be published latched on topic "~/io_info" where "~" is the private namespace of the I/O group.
# This message contains the complete description of the I/O group, i.e. all pins at once.
# Raw Analog and Digitized Analog pins can be duplicated, i.e. it is possible that one pin can be reported both with the
# "raw" and "digitized" interface.

Header header  # Stamp should be time of the driver startup. frame_id should identify the I/O board. It does not need
               # to be a TF frame.
DigitalIOInfo[] digital  # Digital I/O pins.
RawAnalogIOInfo[] raw_analog  # Raw analog I/O pins (directly working with the represented analog value).
DigitizedAnalogIOInfo[] digitized_analog  # Digitized analog I/O pins (working with the integral output of an ADC).

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: electronic_io_msgs/DigitalIOInfo
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# Metadata of a digital I/O pin (whose value is represented as a boolean).

IOPinInfo pin  # The I/O pin metadata.
================================================================================
MSG: electronic_io_msgs/IOPinInfo
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# Metadata of a single I/O pin.

string name  # Name of the pin (from SDK, datasheet, package marking etc.)
bool is_readable  # True if the pin value can be read (can also be true for output pins if readback is supported).
bool is_writable  # True if the pin value can be written to (output pins).
bool can_persist  # Whether a writable pin's value can be persisted (i.e. stored in some kind of non-volatile memory).
================================================================================
MSG: electronic_io_msgs/RawAnalogIOInfo
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# Metadata of a raw analog I/O pin (working directly with the represented analog values).

IOPinInfo pin  # The I/O pin metadata.
string unit  # The unit in which the analog value is expressed (if possible, it should be an SI unit).
duration sampling_period  # Duration of sampling (inverse of sampling frequency).
                          # If not known, output-only or variable, set to 0.
float64 min_value  # Minimum value that can be read from / written to the pin.
                   # If possible, it should be in SI units. Use -inf if unbounded (or zeros for both min/max).
                   # Do not use NaN. 
float64 max_value  # Maximum value that can be read from / written to the pin.
                   # If possible, it should be in SI units. Use +inf if range is not known (or zeros for both min/max).
                   # Do not use NaN.

================================================================================
MSG: electronic_io_msgs/DigitizedAnalogIOInfo
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# Metadata of a digitized analog I/O pin (working with ADC values).

IOPinInfo pin  # The I/O pin metadata.
duration sampling_period  # Duration of sampling (inverse of sampling frequency).
                          # If not known, output-only or variable, set to 0.
int64 min_value  # Minimum value that can be read from / written to the pin (usually zero).
int64 max_value  # Maximum value that can be read from / written to the pin. If equal to min_value, there is no limit.
"""
  __slots__ = ['header','digital','raw_analog','digitized_analog']
  _slot_types = ['std_msgs/Header','electronic_io_msgs/DigitalIOInfo[]','electronic_io_msgs/RawAnalogIOInfo[]','electronic_io_msgs/DigitizedAnalogIOInfo[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,digital,raw_analog,digitized_analog

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(IOInfo, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.digital is None:
        self.digital = []
      if self.raw_analog is None:
        self.raw_analog = []
      if self.digitized_analog is None:
        self.digitized_analog = []
    else:
      self.header = std_msgs.msg.Header()
      self.digital = []
      self.raw_analog = []
      self.digitized_analog = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.digital)
      buff.write(_struct_I.pack(length))
      for val1 in self.digital:
        _v1 = val1.pin
        _x = _v1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v1
        buff.write(_get_struct_3B().pack(_x.is_readable, _x.is_writable, _x.can_persist))
      length = len(self.raw_analog)
      buff.write(_struct_I.pack(length))
      for val1 in self.raw_analog:
        _v2 = val1.pin
        _x = _v2.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v2
        buff.write(_get_struct_3B().pack(_x.is_readable, _x.is_writable, _x.can_persist))
        _x = val1.unit
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v3 = val1.sampling_period
        _x = _v3
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _x = val1
        buff.write(_get_struct_2d().pack(_x.min_value, _x.max_value))
      length = len(self.digitized_analog)
      buff.write(_struct_I.pack(length))
      for val1 in self.digitized_analog:
        _v4 = val1.pin
        _x = _v4.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v4
        buff.write(_get_struct_3B().pack(_x.is_readable, _x.is_writable, _x.can_persist))
        _v5 = val1.sampling_period
        _x = _v5
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _x = val1
        buff.write(_get_struct_2q().pack(_x.min_value, _x.max_value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.digital is None:
        self.digital = None
      if self.raw_analog is None:
        self.raw_analog = None
      if self.digitized_analog is None:
        self.digitized_analog = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.digital = []
      for i in range(0, length):
        val1 = electronic_io_msgs.msg.DigitalIOInfo()
        _v6 = val1.pin
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v6.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v6.name = str[start:end]
        _x = _v6
        start = end
        end += 3
        (_x.is_readable, _x.is_writable, _x.can_persist,) = _get_struct_3B().unpack(str[start:end])
        _v6.is_readable = bool(_v6.is_readable)
        _v6.is_writable = bool(_v6.is_writable)
        _v6.can_persist = bool(_v6.can_persist)
        self.digital.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.raw_analog = []
      for i in range(0, length):
        val1 = electronic_io_msgs.msg.RawAnalogIOInfo()
        _v7 = val1.pin
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v7.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v7.name = str[start:end]
        _x = _v7
        start = end
        end += 3
        (_x.is_readable, _x.is_writable, _x.can_persist,) = _get_struct_3B().unpack(str[start:end])
        _v7.is_readable = bool(_v7.is_readable)
        _v7.is_writable = bool(_v7.is_writable)
        _v7.can_persist = bool(_v7.can_persist)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.unit = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.unit = str[start:end]
        _v8 = val1.sampling_period
        _x = _v8
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        _x = val1
        start = end
        end += 16
        (_x.min_value, _x.max_value,) = _get_struct_2d().unpack(str[start:end])
        self.raw_analog.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.digitized_analog = []
      for i in range(0, length):
        val1 = electronic_io_msgs.msg.DigitizedAnalogIOInfo()
        _v9 = val1.pin
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v9.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v9.name = str[start:end]
        _x = _v9
        start = end
        end += 3
        (_x.is_readable, _x.is_writable, _x.can_persist,) = _get_struct_3B().unpack(str[start:end])
        _v9.is_readable = bool(_v9.is_readable)
        _v9.is_writable = bool(_v9.is_writable)
        _v9.can_persist = bool(_v9.can_persist)
        _v10 = val1.sampling_period
        _x = _v10
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        _x = val1
        start = end
        end += 16
        (_x.min_value, _x.max_value,) = _get_struct_2q().unpack(str[start:end])
        self.digitized_analog.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.digital)
      buff.write(_struct_I.pack(length))
      for val1 in self.digital:
        _v11 = val1.pin
        _x = _v11.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v11
        buff.write(_get_struct_3B().pack(_x.is_readable, _x.is_writable, _x.can_persist))
      length = len(self.raw_analog)
      buff.write(_struct_I.pack(length))
      for val1 in self.raw_analog:
        _v12 = val1.pin
        _x = _v12.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v12
        buff.write(_get_struct_3B().pack(_x.is_readable, _x.is_writable, _x.can_persist))
        _x = val1.unit
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v13 = val1.sampling_period
        _x = _v13
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _x = val1
        buff.write(_get_struct_2d().pack(_x.min_value, _x.max_value))
      length = len(self.digitized_analog)
      buff.write(_struct_I.pack(length))
      for val1 in self.digitized_analog:
        _v14 = val1.pin
        _x = _v14.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v14
        buff.write(_get_struct_3B().pack(_x.is_readable, _x.is_writable, _x.can_persist))
        _v15 = val1.sampling_period
        _x = _v15
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _x = val1
        buff.write(_get_struct_2q().pack(_x.min_value, _x.max_value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.digital is None:
        self.digital = None
      if self.raw_analog is None:
        self.raw_analog = None
      if self.digitized_analog is None:
        self.digitized_analog = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.digital = []
      for i in range(0, length):
        val1 = electronic_io_msgs.msg.DigitalIOInfo()
        _v16 = val1.pin
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v16.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v16.name = str[start:end]
        _x = _v16
        start = end
        end += 3
        (_x.is_readable, _x.is_writable, _x.can_persist,) = _get_struct_3B().unpack(str[start:end])
        _v16.is_readable = bool(_v16.is_readable)
        _v16.is_writable = bool(_v16.is_writable)
        _v16.can_persist = bool(_v16.can_persist)
        self.digital.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.raw_analog = []
      for i in range(0, length):
        val1 = electronic_io_msgs.msg.RawAnalogIOInfo()
        _v17 = val1.pin
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v17.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v17.name = str[start:end]
        _x = _v17
        start = end
        end += 3
        (_x.is_readable, _x.is_writable, _x.can_persist,) = _get_struct_3B().unpack(str[start:end])
        _v17.is_readable = bool(_v17.is_readable)
        _v17.is_writable = bool(_v17.is_writable)
        _v17.can_persist = bool(_v17.can_persist)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.unit = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.unit = str[start:end]
        _v18 = val1.sampling_period
        _x = _v18
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        _x = val1
        start = end
        end += 16
        (_x.min_value, _x.max_value,) = _get_struct_2d().unpack(str[start:end])
        self.raw_analog.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.digitized_analog = []
      for i in range(0, length):
        val1 = electronic_io_msgs.msg.DigitizedAnalogIOInfo()
        _v19 = val1.pin
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v19.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v19.name = str[start:end]
        _x = _v19
        start = end
        end += 3
        (_x.is_readable, _x.is_writable, _x.can_persist,) = _get_struct_3B().unpack(str[start:end])
        _v19.is_readable = bool(_v19.is_readable)
        _v19.is_writable = bool(_v19.is_writable)
        _v19.can_persist = bool(_v19.can_persist)
        _v20 = val1.sampling_period
        _x = _v20
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        _x = val1
        start = end
        end += 16
        (_x.min_value, _x.max_value,) = _get_struct_2q().unpack(str[start:end])
        self.digitized_analog.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2d = None
def _get_struct_2d():
    global _struct_2d
    if _struct_2d is None:
        _struct_2d = struct.Struct("<2d")
    return _struct_2d
_struct_2i = None
def _get_struct_2i():
    global _struct_2i
    if _struct_2i is None:
        _struct_2i = struct.Struct("<2i")
    return _struct_2i
_struct_2q = None
def _get_struct_2q():
    global _struct_2q
    if _struct_2q is None:
        _struct_2q = struct.Struct("<2q")
    return _struct_2q
_struct_3B = None
def _get_struct_3B():
    global _struct_3B
    if _struct_3B is None:
        _struct_3B = struct.Struct("<3B")
    return _struct_3B
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
