# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from electronic_io_msgs/ReadRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class ReadRequest(genpy.Message):
  _md5sum = "ddef0757bfd106366544ca4a40c75f34"
  _type = "electronic_io_msgs/ReadRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# Read a (sub)set of I/O pins (ideally synchronously if supported by the hardware).

string[] digital_pins  # Names of digital I/O pins to read.
string[] raw_analog_pins  # Names of raw analog I/O pins to read.
string[] digitized_analog_pins  # Names of digitized analog I/O pins to read.
"""
  __slots__ = ['digital_pins','raw_analog_pins','digitized_analog_pins']
  _slot_types = ['string[]','string[]','string[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       digital_pins,raw_analog_pins,digitized_analog_pins

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ReadRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.digital_pins is None:
        self.digital_pins = []
      if self.raw_analog_pins is None:
        self.raw_analog_pins = []
      if self.digitized_analog_pins is None:
        self.digitized_analog_pins = []
    else:
      self.digital_pins = []
      self.raw_analog_pins = []
      self.digitized_analog_pins = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.digital_pins)
      buff.write(_struct_I.pack(length))
      for val1 in self.digital_pins:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.raw_analog_pins)
      buff.write(_struct_I.pack(length))
      for val1 in self.raw_analog_pins:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.digitized_analog_pins)
      buff.write(_struct_I.pack(length))
      for val1 in self.digitized_analog_pins:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.digital_pins = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.digital_pins.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.raw_analog_pins = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.raw_analog_pins.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.digitized_analog_pins = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.digitized_analog_pins.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.digital_pins)
      buff.write(_struct_I.pack(length))
      for val1 in self.digital_pins:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.raw_analog_pins)
      buff.write(_struct_I.pack(length))
      for val1 in self.raw_analog_pins:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.digitized_analog_pins)
      buff.write(_struct_I.pack(length))
      for val1 in self.digitized_analog_pins:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.digital_pins = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.digital_pins.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.raw_analog_pins = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.raw_analog_pins.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.digitized_analog_pins = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.digitized_analog_pins.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from electronic_io_msgs/ReadResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import electronic_io_msgs.msg
import std_msgs.msg

class ReadResponse(genpy.Message):
  _md5sum = "8aa680a5af2f04b513293034badf2742"
  _type = "electronic_io_msgs/ReadResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """Readings readings  # The read values.


================================================================================
MSG: electronic_io_msgs/Readings
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# Readings of a (sub)set of I/O pins.

Header header  # Timestamp of all readings (or of the first reading if synchronous reads are not supported).
               # frame_id should be the same as in the corresponding IOInfo message.
DigitalReading[] digital
RawAnalogReading[] raw_analog
DigitizedAnalogReading[] digitized_analog

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: electronic_io_msgs/DigitalReading
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# One reading of a digital I/O pin.

string name  # Name of the pin (from SDK, datasheet, package marking etc.)
bool value  # Value of the pin (true = ON, false = OFF).

================================================================================
MSG: electronic_io_msgs/RawAnalogReading
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# One reading of a raw analog I/O pin (working directly with the represented analog value).

string name  # Name of the pin (from SDK, datasheet, package marking etc.)
float64 value  # The represented analog value. If possible, it should be in SI units.

================================================================================
MSG: electronic_io_msgs/DigitizedAnalogReading
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# One reading of a digitized analog I/O pin (working with ADC values).

string name  # Name of the pin (from SDK, datasheet, package marking etc.)
int64 value  # The ADC value.
"""
  __slots__ = ['readings']
  _slot_types = ['electronic_io_msgs/Readings']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       readings

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ReadResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.readings is None:
        self.readings = electronic_io_msgs.msg.Readings()
    else:
      self.readings = electronic_io_msgs.msg.Readings()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.readings.header.seq, _x.readings.header.stamp.secs, _x.readings.header.stamp.nsecs))
      _x = self.readings.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.readings.digital)
      buff.write(_struct_I.pack(length))
      for val1 in self.readings.digital:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.value
        buff.write(_get_struct_B().pack(_x))
      length = len(self.readings.raw_analog)
      buff.write(_struct_I.pack(length))
      for val1 in self.readings.raw_analog:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.value
        buff.write(_get_struct_d().pack(_x))
      length = len(self.readings.digitized_analog)
      buff.write(_struct_I.pack(length))
      for val1 in self.readings.digitized_analog:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.value
        buff.write(_get_struct_q().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.readings is None:
        self.readings = electronic_io_msgs.msg.Readings()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.readings.header.seq, _x.readings.header.stamp.secs, _x.readings.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.readings.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.readings.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.readings.digital = []
      for i in range(0, length):
        val1 = electronic_io_msgs.msg.DigitalReading()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        start = end
        end += 1
        (val1.value,) = _get_struct_B().unpack(str[start:end])
        val1.value = bool(val1.value)
        self.readings.digital.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.readings.raw_analog = []
      for i in range(0, length):
        val1 = electronic_io_msgs.msg.RawAnalogReading()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        start = end
        end += 8
        (val1.value,) = _get_struct_d().unpack(str[start:end])
        self.readings.raw_analog.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.readings.digitized_analog = []
      for i in range(0, length):
        val1 = electronic_io_msgs.msg.DigitizedAnalogReading()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        start = end
        end += 8
        (val1.value,) = _get_struct_q().unpack(str[start:end])
        self.readings.digitized_analog.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.readings.header.seq, _x.readings.header.stamp.secs, _x.readings.header.stamp.nsecs))
      _x = self.readings.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.readings.digital)
      buff.write(_struct_I.pack(length))
      for val1 in self.readings.digital:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.value
        buff.write(_get_struct_B().pack(_x))
      length = len(self.readings.raw_analog)
      buff.write(_struct_I.pack(length))
      for val1 in self.readings.raw_analog:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.value
        buff.write(_get_struct_d().pack(_x))
      length = len(self.readings.digitized_analog)
      buff.write(_struct_I.pack(length))
      for val1 in self.readings.digitized_analog:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.value
        buff.write(_get_struct_q().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.readings is None:
        self.readings = electronic_io_msgs.msg.Readings()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.readings.header.seq, _x.readings.header.stamp.secs, _x.readings.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.readings.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.readings.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.readings.digital = []
      for i in range(0, length):
        val1 = electronic_io_msgs.msg.DigitalReading()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        start = end
        end += 1
        (val1.value,) = _get_struct_B().unpack(str[start:end])
        val1.value = bool(val1.value)
        self.readings.digital.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.readings.raw_analog = []
      for i in range(0, length):
        val1 = electronic_io_msgs.msg.RawAnalogReading()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        start = end
        end += 8
        (val1.value,) = _get_struct_d().unpack(str[start:end])
        self.readings.raw_analog.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.readings.digitized_analog = []
      for i in range(0, length):
        val1 = electronic_io_msgs.msg.DigitizedAnalogReading()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        start = end
        end += 8
        (val1.value,) = _get_struct_q().unpack(str[start:end])
        self.readings.digitized_analog.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_d = None
def _get_struct_d():
    global _struct_d
    if _struct_d is None:
        _struct_d = struct.Struct("<d")
    return _struct_d
_struct_q = None
def _get_struct_q():
    global _struct_q
    if _struct_q is None:
        _struct_q = struct.Struct("<q")
    return _struct_q
class Read(object):
  _type          = 'electronic_io_msgs/Read'
  _md5sum = '91886bb3aee1e29f2d2fa6d10c93a41e'
  _request_class  = ReadRequest
  _response_class = ReadResponse
