# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from electronic_io_msgs/WriteRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import electronic_io_msgs.msg

class WriteRequest(genpy.Message):
  _md5sum = "af7fc4e8b3917015f7b281dfaa23bd85"
  _type = "electronic_io_msgs/WriteRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# Write a (sub)set of I/O pins (ideally synchronously if supported by the hardware).

DigitalWrite[] digital
# Analog pins that can be accessed through both "raw" and "digitized" interfaces should each only appear in one of the
# following fields.
RawAnalogWrite[] raw_analog
DigitizedAnalogWrite[] digitized_analog

================================================================================
MSG: electronic_io_msgs/DigitalWrite
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# One write request of a digital I/O pin.

string name  # Name of the pin (from SDK, datasheet, package marking etc.)
bool value  # Requested value of the pin (true = ON, false = OFF).
bool persist  # If true and the pin has can_persist set to True, try to make the value persistent.
================================================================================
MSG: electronic_io_msgs/RawAnalogWrite
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# One write request of a raw analog I/O pin (working with the represented analog values).

string name  # Name of the pin (from SDK, datasheet, package marking etc.)
float64 value  # The represented analog value. If possible, it should be in SI units.
bool persist  # If true and the pin has can_persist set to True, try to make the value persistent.
================================================================================
MSG: electronic_io_msgs/DigitizedAnalogWrite
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# One write request of a digitized analog I/O pin (working with raw ADC values).

string name  # Name of the pin (from SDK, datasheet, package marking etc.)
int64 value  # The requested ADC value.
bool persist  # If true and the pin has can_persist set to True, try to make the value persistent."""
  __slots__ = ['digital','raw_analog','digitized_analog']
  _slot_types = ['electronic_io_msgs/DigitalWrite[]','electronic_io_msgs/RawAnalogWrite[]','electronic_io_msgs/DigitizedAnalogWrite[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       digital,raw_analog,digitized_analog

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(WriteRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.digital is None:
        self.digital = []
      if self.raw_analog is None:
        self.raw_analog = []
      if self.digitized_analog is None:
        self.digitized_analog = []
    else:
      self.digital = []
      self.raw_analog = []
      self.digitized_analog = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.digital)
      buff.write(_struct_I.pack(length))
      for val1 in self.digital:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_2B().pack(_x.value, _x.persist))
      length = len(self.raw_analog)
      buff.write(_struct_I.pack(length))
      for val1 in self.raw_analog:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_dB().pack(_x.value, _x.persist))
      length = len(self.digitized_analog)
      buff.write(_struct_I.pack(length))
      for val1 in self.digitized_analog:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_qB().pack(_x.value, _x.persist))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.digital is None:
        self.digital = None
      if self.raw_analog is None:
        self.raw_analog = None
      if self.digitized_analog is None:
        self.digitized_analog = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.digital = []
      for i in range(0, length):
        val1 = electronic_io_msgs.msg.DigitalWrite()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 2
        (_x.value, _x.persist,) = _get_struct_2B().unpack(str[start:end])
        val1.value = bool(val1.value)
        val1.persist = bool(val1.persist)
        self.digital.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.raw_analog = []
      for i in range(0, length):
        val1 = electronic_io_msgs.msg.RawAnalogWrite()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.value, _x.persist,) = _get_struct_dB().unpack(str[start:end])
        val1.persist = bool(val1.persist)
        self.raw_analog.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.digitized_analog = []
      for i in range(0, length):
        val1 = electronic_io_msgs.msg.DigitizedAnalogWrite()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.value, _x.persist,) = _get_struct_qB().unpack(str[start:end])
        val1.persist = bool(val1.persist)
        self.digitized_analog.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.digital)
      buff.write(_struct_I.pack(length))
      for val1 in self.digital:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_2B().pack(_x.value, _x.persist))
      length = len(self.raw_analog)
      buff.write(_struct_I.pack(length))
      for val1 in self.raw_analog:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_dB().pack(_x.value, _x.persist))
      length = len(self.digitized_analog)
      buff.write(_struct_I.pack(length))
      for val1 in self.digitized_analog:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_qB().pack(_x.value, _x.persist))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.digital is None:
        self.digital = None
      if self.raw_analog is None:
        self.raw_analog = None
      if self.digitized_analog is None:
        self.digitized_analog = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.digital = []
      for i in range(0, length):
        val1 = electronic_io_msgs.msg.DigitalWrite()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 2
        (_x.value, _x.persist,) = _get_struct_2B().unpack(str[start:end])
        val1.value = bool(val1.value)
        val1.persist = bool(val1.persist)
        self.digital.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.raw_analog = []
      for i in range(0, length):
        val1 = electronic_io_msgs.msg.RawAnalogWrite()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.value, _x.persist,) = _get_struct_dB().unpack(str[start:end])
        val1.persist = bool(val1.persist)
        self.raw_analog.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.digitized_analog = []
      for i in range(0, length):
        val1 = electronic_io_msgs.msg.DigitizedAnalogWrite()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.value, _x.persist,) = _get_struct_qB().unpack(str[start:end])
        val1.persist = bool(val1.persist)
        self.digitized_analog.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_dB = None
def _get_struct_dB():
    global _struct_dB
    if _struct_dB is None:
        _struct_dB = struct.Struct("<dB")
    return _struct_dB
_struct_qB = None
def _get_struct_qB():
    global _struct_qB
    if _struct_qB is None:
        _struct_qB = struct.Struct("<qB")
    return _struct_qB
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from electronic_io_msgs/WriteResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class WriteResponse(genpy.Message):
  _md5sum = "d41d8cd98f00b204e9800998ecf8427e"
  _type = "electronic_io_msgs/WriteResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# If a failure occurs, the service server should throw an exception.

"""
  __slots__ = []
  _slot_types = []

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(WriteResponse, self).__init__(*args, **kwds)

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      pass
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      pass
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
class Write(object):
  _type          = 'electronic_io_msgs/Write'
  _md5sum = 'af7fc4e8b3917015f7b281dfaa23bd85'
  _request_class  = WriteRequest
  _response_class = WriteResponse
