// Auto-generated. Do not edit!

// (in-package electronic_io_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let DigitalIOInfo = require('./DigitalIOInfo.js');
let RawAnalogIOInfo = require('./RawAnalogIOInfo.js');
let DigitizedAnalogIOInfo = require('./DigitizedAnalogIOInfo.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class IOInfo {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.digital = null;
      this.raw_analog = null;
      this.digitized_analog = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('digital')) {
        this.digital = initObj.digital
      }
      else {
        this.digital = [];
      }
      if (initObj.hasOwnProperty('raw_analog')) {
        this.raw_analog = initObj.raw_analog
      }
      else {
        this.raw_analog = [];
      }
      if (initObj.hasOwnProperty('digitized_analog')) {
        this.digitized_analog = initObj.digitized_analog
      }
      else {
        this.digitized_analog = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type IOInfo
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [digital]
    // Serialize the length for message field [digital]
    bufferOffset = _serializer.uint32(obj.digital.length, buffer, bufferOffset);
    obj.digital.forEach((val) => {
      bufferOffset = DigitalIOInfo.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [raw_analog]
    // Serialize the length for message field [raw_analog]
    bufferOffset = _serializer.uint32(obj.raw_analog.length, buffer, bufferOffset);
    obj.raw_analog.forEach((val) => {
      bufferOffset = RawAnalogIOInfo.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [digitized_analog]
    // Serialize the length for message field [digitized_analog]
    bufferOffset = _serializer.uint32(obj.digitized_analog.length, buffer, bufferOffset);
    obj.digitized_analog.forEach((val) => {
      bufferOffset = DigitizedAnalogIOInfo.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type IOInfo
    let len;
    let data = new IOInfo(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [digital]
    // Deserialize array length for message field [digital]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.digital = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.digital[i] = DigitalIOInfo.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [raw_analog]
    // Deserialize array length for message field [raw_analog]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.raw_analog = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.raw_analog[i] = RawAnalogIOInfo.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [digitized_analog]
    // Deserialize array length for message field [digitized_analog]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.digitized_analog = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.digitized_analog[i] = DigitizedAnalogIOInfo.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    object.digital.forEach((val) => {
      length += DigitalIOInfo.getMessageSize(val);
    });
    object.raw_analog.forEach((val) => {
      length += RawAnalogIOInfo.getMessageSize(val);
    });
    object.digitized_analog.forEach((val) => {
      length += DigitizedAnalogIOInfo.getMessageSize(val);
    });
    return length + 12;
  }

  static datatype() {
    // Returns string type for a message object
    return 'electronic_io_msgs/IOInfo';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '8e9ddc7436a29885ebfe415d889e12d7';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # Metadata of a group of digital or analog I/O pins.
    # This message should be published latched on topic "~/io_info" where "~" is the private namespace of the I/O group.
    # This message contains the complete description of the I/O group, i.e. all pins at once.
    # Raw Analog and Digitized Analog pins can be duplicated, i.e. it is possible that one pin can be reported both with the
    # "raw" and "digitized" interface.
    
    Header header  # Stamp should be time of the driver startup. frame_id should identify the I/O board. It does not need
                   # to be a TF frame.
    DigitalIOInfo[] digital  # Digital I/O pins.
    RawAnalogIOInfo[] raw_analog  # Raw analog I/O pins (directly working with the represented analog value).
    DigitizedAnalogIOInfo[] digitized_analog  # Digitized analog I/O pins (working with the integral output of an ADC).
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: electronic_io_msgs/DigitalIOInfo
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # Metadata of a digital I/O pin (whose value is represented as a boolean).
    
    IOPinInfo pin  # The I/O pin metadata.
    ================================================================================
    MSG: electronic_io_msgs/IOPinInfo
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # Metadata of a single I/O pin.
    
    string name  # Name of the pin (from SDK, datasheet, package marking etc.)
    bool is_readable  # True if the pin value can be read (can also be true for output pins if readback is supported).
    bool is_writable  # True if the pin value can be written to (output pins).
    bool can_persist  # Whether a writable pin's value can be persisted (i.e. stored in some kind of non-volatile memory).
    ================================================================================
    MSG: electronic_io_msgs/RawAnalogIOInfo
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # Metadata of a raw analog I/O pin (working directly with the represented analog values).
    
    IOPinInfo pin  # The I/O pin metadata.
    string unit  # The unit in which the analog value is expressed (if possible, it should be an SI unit).
    duration sampling_period  # Duration of sampling (inverse of sampling frequency).
                              # If not known, output-only or variable, set to 0.
    float64 min_value  # Minimum value that can be read from / written to the pin.
                       # If possible, it should be in SI units. Use -inf if unbounded (or zeros for both min/max).
                       # Do not use NaN. 
    float64 max_value  # Maximum value that can be read from / written to the pin.
                       # If possible, it should be in SI units. Use +inf if range is not known (or zeros for both min/max).
                       # Do not use NaN.
    
    ================================================================================
    MSG: electronic_io_msgs/DigitizedAnalogIOInfo
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # Metadata of a digitized analog I/O pin (working with ADC values).
    
    IOPinInfo pin  # The I/O pin metadata.
    duration sampling_period  # Duration of sampling (inverse of sampling frequency).
                              # If not known, output-only or variable, set to 0.
    int64 min_value  # Minimum value that can be read from / written to the pin (usually zero).
    int64 max_value  # Maximum value that can be read from / written to the pin. If equal to min_value, there is no limit.
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new IOInfo(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.digital !== undefined) {
      resolved.digital = new Array(msg.digital.length);
      for (let i = 0; i < resolved.digital.length; ++i) {
        resolved.digital[i] = DigitalIOInfo.Resolve(msg.digital[i]);
      }
    }
    else {
      resolved.digital = []
    }

    if (msg.raw_analog !== undefined) {
      resolved.raw_analog = new Array(msg.raw_analog.length);
      for (let i = 0; i < resolved.raw_analog.length; ++i) {
        resolved.raw_analog[i] = RawAnalogIOInfo.Resolve(msg.raw_analog[i]);
      }
    }
    else {
      resolved.raw_analog = []
    }

    if (msg.digitized_analog !== undefined) {
      resolved.digitized_analog = new Array(msg.digitized_analog.length);
      for (let i = 0; i < resolved.digitized_analog.length; ++i) {
        resolved.digitized_analog[i] = DigitizedAnalogIOInfo.Resolve(msg.digitized_analog[i]);
      }
    }
    else {
      resolved.digitized_analog = []
    }

    return resolved;
    }
};

module.exports = IOInfo;
