// Auto-generated. Do not edit!

// (in-package electronic_io_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let IOPinInfo = require('./IOPinInfo.js');

//-----------------------------------------------------------

class RawAnalogIOInfo {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.pin = null;
      this.unit = null;
      this.sampling_period = null;
      this.min_value = null;
      this.max_value = null;
    }
    else {
      if (initObj.hasOwnProperty('pin')) {
        this.pin = initObj.pin
      }
      else {
        this.pin = new IOPinInfo();
      }
      if (initObj.hasOwnProperty('unit')) {
        this.unit = initObj.unit
      }
      else {
        this.unit = '';
      }
      if (initObj.hasOwnProperty('sampling_period')) {
        this.sampling_period = initObj.sampling_period
      }
      else {
        this.sampling_period = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('min_value')) {
        this.min_value = initObj.min_value
      }
      else {
        this.min_value = 0.0;
      }
      if (initObj.hasOwnProperty('max_value')) {
        this.max_value = initObj.max_value
      }
      else {
        this.max_value = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type RawAnalogIOInfo
    // Serialize message field [pin]
    bufferOffset = IOPinInfo.serialize(obj.pin, buffer, bufferOffset);
    // Serialize message field [unit]
    bufferOffset = _serializer.string(obj.unit, buffer, bufferOffset);
    // Serialize message field [sampling_period]
    bufferOffset = _serializer.duration(obj.sampling_period, buffer, bufferOffset);
    // Serialize message field [min_value]
    bufferOffset = _serializer.float64(obj.min_value, buffer, bufferOffset);
    // Serialize message field [max_value]
    bufferOffset = _serializer.float64(obj.max_value, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type RawAnalogIOInfo
    let len;
    let data = new RawAnalogIOInfo(null);
    // Deserialize message field [pin]
    data.pin = IOPinInfo.deserialize(buffer, bufferOffset);
    // Deserialize message field [unit]
    data.unit = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [sampling_period]
    data.sampling_period = _deserializer.duration(buffer, bufferOffset);
    // Deserialize message field [min_value]
    data.min_value = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [max_value]
    data.max_value = _deserializer.float64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += IOPinInfo.getMessageSize(object.pin);
    length += _getByteLength(object.unit);
    return length + 28;
  }

  static datatype() {
    // Returns string type for a message object
    return 'electronic_io_msgs/RawAnalogIOInfo';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '4cceb87372d4f74c83ef60cd49410011';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # Metadata of a raw analog I/O pin (working directly with the represented analog values).
    
    IOPinInfo pin  # The I/O pin metadata.
    string unit  # The unit in which the analog value is expressed (if possible, it should be an SI unit).
    duration sampling_period  # Duration of sampling (inverse of sampling frequency).
                              # If not known, output-only or variable, set to 0.
    float64 min_value  # Minimum value that can be read from / written to the pin.
                       # If possible, it should be in SI units. Use -inf if unbounded (or zeros for both min/max).
                       # Do not use NaN. 
    float64 max_value  # Maximum value that can be read from / written to the pin.
                       # If possible, it should be in SI units. Use +inf if range is not known (or zeros for both min/max).
                       # Do not use NaN.
    
    ================================================================================
    MSG: electronic_io_msgs/IOPinInfo
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # Metadata of a single I/O pin.
    
    string name  # Name of the pin (from SDK, datasheet, package marking etc.)
    bool is_readable  # True if the pin value can be read (can also be true for output pins if readback is supported).
    bool is_writable  # True if the pin value can be written to (output pins).
    bool can_persist  # Whether a writable pin's value can be persisted (i.e. stored in some kind of non-volatile memory).
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new RawAnalogIOInfo(null);
    if (msg.pin !== undefined) {
      resolved.pin = IOPinInfo.Resolve(msg.pin)
    }
    else {
      resolved.pin = new IOPinInfo()
    }

    if (msg.unit !== undefined) {
      resolved.unit = msg.unit;
    }
    else {
      resolved.unit = ''
    }

    if (msg.sampling_period !== undefined) {
      resolved.sampling_period = msg.sampling_period;
    }
    else {
      resolved.sampling_period = {secs: 0, nsecs: 0}
    }

    if (msg.min_value !== undefined) {
      resolved.min_value = msg.min_value;
    }
    else {
      resolved.min_value = 0.0
    }

    if (msg.max_value !== undefined) {
      resolved.max_value = msg.max_value;
    }
    else {
      resolved.max_value = 0.0
    }

    return resolved;
    }
};

module.exports = RawAnalogIOInfo;
