// Auto-generated. Do not edit!

// (in-package electronic_io_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let DigitalReading = require('./DigitalReading.js');
let RawAnalogReading = require('./RawAnalogReading.js');
let DigitizedAnalogReading = require('./DigitizedAnalogReading.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class Readings {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.digital = null;
      this.raw_analog = null;
      this.digitized_analog = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('digital')) {
        this.digital = initObj.digital
      }
      else {
        this.digital = [];
      }
      if (initObj.hasOwnProperty('raw_analog')) {
        this.raw_analog = initObj.raw_analog
      }
      else {
        this.raw_analog = [];
      }
      if (initObj.hasOwnProperty('digitized_analog')) {
        this.digitized_analog = initObj.digitized_analog
      }
      else {
        this.digitized_analog = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Readings
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [digital]
    // Serialize the length for message field [digital]
    bufferOffset = _serializer.uint32(obj.digital.length, buffer, bufferOffset);
    obj.digital.forEach((val) => {
      bufferOffset = DigitalReading.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [raw_analog]
    // Serialize the length for message field [raw_analog]
    bufferOffset = _serializer.uint32(obj.raw_analog.length, buffer, bufferOffset);
    obj.raw_analog.forEach((val) => {
      bufferOffset = RawAnalogReading.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [digitized_analog]
    // Serialize the length for message field [digitized_analog]
    bufferOffset = _serializer.uint32(obj.digitized_analog.length, buffer, bufferOffset);
    obj.digitized_analog.forEach((val) => {
      bufferOffset = DigitizedAnalogReading.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Readings
    let len;
    let data = new Readings(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [digital]
    // Deserialize array length for message field [digital]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.digital = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.digital[i] = DigitalReading.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [raw_analog]
    // Deserialize array length for message field [raw_analog]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.raw_analog = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.raw_analog[i] = RawAnalogReading.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [digitized_analog]
    // Deserialize array length for message field [digitized_analog]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.digitized_analog = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.digitized_analog[i] = DigitizedAnalogReading.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    object.digital.forEach((val) => {
      length += DigitalReading.getMessageSize(val);
    });
    object.raw_analog.forEach((val) => {
      length += RawAnalogReading.getMessageSize(val);
    });
    object.digitized_analog.forEach((val) => {
      length += DigitizedAnalogReading.getMessageSize(val);
    });
    return length + 12;
  }

  static datatype() {
    // Returns string type for a message object
    return 'electronic_io_msgs/Readings';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '4b3397f77e5f99450c809e9b6ef98a1f';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # Readings of a (sub)set of I/O pins.
    
    Header header  # Timestamp of all readings (or of the first reading if synchronous reads are not supported).
                   # frame_id should be the same as in the corresponding IOInfo message.
    DigitalReading[] digital
    RawAnalogReading[] raw_analog
    DigitizedAnalogReading[] digitized_analog
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: electronic_io_msgs/DigitalReading
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # One reading of a digital I/O pin.
    
    string name  # Name of the pin (from SDK, datasheet, package marking etc.)
    bool value  # Value of the pin (true = ON, false = OFF).
    
    ================================================================================
    MSG: electronic_io_msgs/RawAnalogReading
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # One reading of a raw analog I/O pin (working directly with the represented analog value).
    
    string name  # Name of the pin (from SDK, datasheet, package marking etc.)
    float64 value  # The represented analog value. If possible, it should be in SI units.
    
    ================================================================================
    MSG: electronic_io_msgs/DigitizedAnalogReading
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # One reading of a digitized analog I/O pin (working with ADC values).
    
    string name  # Name of the pin (from SDK, datasheet, package marking etc.)
    int64 value  # The ADC value.
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Readings(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.digital !== undefined) {
      resolved.digital = new Array(msg.digital.length);
      for (let i = 0; i < resolved.digital.length; ++i) {
        resolved.digital[i] = DigitalReading.Resolve(msg.digital[i]);
      }
    }
    else {
      resolved.digital = []
    }

    if (msg.raw_analog !== undefined) {
      resolved.raw_analog = new Array(msg.raw_analog.length);
      for (let i = 0; i < resolved.raw_analog.length; ++i) {
        resolved.raw_analog[i] = RawAnalogReading.Resolve(msg.raw_analog[i]);
      }
    }
    else {
      resolved.raw_analog = []
    }

    if (msg.digitized_analog !== undefined) {
      resolved.digitized_analog = new Array(msg.digitized_analog.length);
      for (let i = 0; i < resolved.digitized_analog.length; ++i) {
        resolved.digitized_analog[i] = DigitizedAnalogReading.Resolve(msg.digitized_analog[i]);
      }
    }
    else {
      resolved.digitized_analog = []
    }

    return resolved;
    }
};

module.exports = Readings;
