// Auto-generated. Do not edit!

// (in-package electronic_io_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

let Readings = require('../msg/Readings.js');

//-----------------------------------------------------------

class ReadRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.digital_pins = null;
      this.raw_analog_pins = null;
      this.digitized_analog_pins = null;
    }
    else {
      if (initObj.hasOwnProperty('digital_pins')) {
        this.digital_pins = initObj.digital_pins
      }
      else {
        this.digital_pins = [];
      }
      if (initObj.hasOwnProperty('raw_analog_pins')) {
        this.raw_analog_pins = initObj.raw_analog_pins
      }
      else {
        this.raw_analog_pins = [];
      }
      if (initObj.hasOwnProperty('digitized_analog_pins')) {
        this.digitized_analog_pins = initObj.digitized_analog_pins
      }
      else {
        this.digitized_analog_pins = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ReadRequest
    // Serialize message field [digital_pins]
    bufferOffset = _arraySerializer.string(obj.digital_pins, buffer, bufferOffset, null);
    // Serialize message field [raw_analog_pins]
    bufferOffset = _arraySerializer.string(obj.raw_analog_pins, buffer, bufferOffset, null);
    // Serialize message field [digitized_analog_pins]
    bufferOffset = _arraySerializer.string(obj.digitized_analog_pins, buffer, bufferOffset, null);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ReadRequest
    let len;
    let data = new ReadRequest(null);
    // Deserialize message field [digital_pins]
    data.digital_pins = _arrayDeserializer.string(buffer, bufferOffset, null)
    // Deserialize message field [raw_analog_pins]
    data.raw_analog_pins = _arrayDeserializer.string(buffer, bufferOffset, null)
    // Deserialize message field [digitized_analog_pins]
    data.digitized_analog_pins = _arrayDeserializer.string(buffer, bufferOffset, null)
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.digital_pins.forEach((val) => {
      length += 4 + _getByteLength(val);
    });
    object.raw_analog_pins.forEach((val) => {
      length += 4 + _getByteLength(val);
    });
    object.digitized_analog_pins.forEach((val) => {
      length += 4 + _getByteLength(val);
    });
    return length + 12;
  }

  static datatype() {
    // Returns string type for a service object
    return 'electronic_io_msgs/ReadRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'ddef0757bfd106366544ca4a40c75f34';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # Read a (sub)set of I/O pins (ideally synchronously if supported by the hardware).
    
    string[] digital_pins  # Names of digital I/O pins to read.
    string[] raw_analog_pins  # Names of raw analog I/O pins to read.
    string[] digitized_analog_pins  # Names of digitized analog I/O pins to read.
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ReadRequest(null);
    if (msg.digital_pins !== undefined) {
      resolved.digital_pins = msg.digital_pins;
    }
    else {
      resolved.digital_pins = []
    }

    if (msg.raw_analog_pins !== undefined) {
      resolved.raw_analog_pins = msg.raw_analog_pins;
    }
    else {
      resolved.raw_analog_pins = []
    }

    if (msg.digitized_analog_pins !== undefined) {
      resolved.digitized_analog_pins = msg.digitized_analog_pins;
    }
    else {
      resolved.digitized_analog_pins = []
    }

    return resolved;
    }
};

class ReadResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.readings = null;
    }
    else {
      if (initObj.hasOwnProperty('readings')) {
        this.readings = initObj.readings
      }
      else {
        this.readings = new Readings();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ReadResponse
    // Serialize message field [readings]
    bufferOffset = Readings.serialize(obj.readings, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ReadResponse
    let len;
    let data = new ReadResponse(null);
    // Deserialize message field [readings]
    data.readings = Readings.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += Readings.getMessageSize(object.readings);
    return length;
  }

  static datatype() {
    // Returns string type for a service object
    return 'electronic_io_msgs/ReadResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '8aa680a5af2f04b513293034badf2742';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    Readings readings  # The read values.
    
    
    ================================================================================
    MSG: electronic_io_msgs/Readings
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # Readings of a (sub)set of I/O pins.
    
    Header header  # Timestamp of all readings (or of the first reading if synchronous reads are not supported).
                   # frame_id should be the same as in the corresponding IOInfo message.
    DigitalReading[] digital
    RawAnalogReading[] raw_analog
    DigitizedAnalogReading[] digitized_analog
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: electronic_io_msgs/DigitalReading
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # One reading of a digital I/O pin.
    
    string name  # Name of the pin (from SDK, datasheet, package marking etc.)
    bool value  # Value of the pin (true = ON, false = OFF).
    
    ================================================================================
    MSG: electronic_io_msgs/RawAnalogReading
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # One reading of a raw analog I/O pin (working directly with the represented analog value).
    
    string name  # Name of the pin (from SDK, datasheet, package marking etc.)
    float64 value  # The represented analog value. If possible, it should be in SI units.
    
    ================================================================================
    MSG: electronic_io_msgs/DigitizedAnalogReading
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # One reading of a digitized analog I/O pin (working with ADC values).
    
    string name  # Name of the pin (from SDK, datasheet, package marking etc.)
    int64 value  # The ADC value.
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ReadResponse(null);
    if (msg.readings !== undefined) {
      resolved.readings = Readings.Resolve(msg.readings)
    }
    else {
      resolved.readings = new Readings()
    }

    return resolved;
    }
};

module.exports = {
  Request: ReadRequest,
  Response: ReadResponse,
  md5sum() { return '91886bb3aee1e29f2d2fa6d10c93a41e'; },
  datatype() { return 'electronic_io_msgs/Read'; }
};
