// Auto-generated. Do not edit!

// (in-package electronic_io_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let DigitalWrite = require('../msg/DigitalWrite.js');
let RawAnalogWrite = require('../msg/RawAnalogWrite.js');
let DigitizedAnalogWrite = require('../msg/DigitizedAnalogWrite.js');

//-----------------------------------------------------------


//-----------------------------------------------------------

class WriteRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.digital = null;
      this.raw_analog = null;
      this.digitized_analog = null;
    }
    else {
      if (initObj.hasOwnProperty('digital')) {
        this.digital = initObj.digital
      }
      else {
        this.digital = [];
      }
      if (initObj.hasOwnProperty('raw_analog')) {
        this.raw_analog = initObj.raw_analog
      }
      else {
        this.raw_analog = [];
      }
      if (initObj.hasOwnProperty('digitized_analog')) {
        this.digitized_analog = initObj.digitized_analog
      }
      else {
        this.digitized_analog = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type WriteRequest
    // Serialize message field [digital]
    // Serialize the length for message field [digital]
    bufferOffset = _serializer.uint32(obj.digital.length, buffer, bufferOffset);
    obj.digital.forEach((val) => {
      bufferOffset = DigitalWrite.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [raw_analog]
    // Serialize the length for message field [raw_analog]
    bufferOffset = _serializer.uint32(obj.raw_analog.length, buffer, bufferOffset);
    obj.raw_analog.forEach((val) => {
      bufferOffset = RawAnalogWrite.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [digitized_analog]
    // Serialize the length for message field [digitized_analog]
    bufferOffset = _serializer.uint32(obj.digitized_analog.length, buffer, bufferOffset);
    obj.digitized_analog.forEach((val) => {
      bufferOffset = DigitizedAnalogWrite.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type WriteRequest
    let len;
    let data = new WriteRequest(null);
    // Deserialize message field [digital]
    // Deserialize array length for message field [digital]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.digital = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.digital[i] = DigitalWrite.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [raw_analog]
    // Deserialize array length for message field [raw_analog]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.raw_analog = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.raw_analog[i] = RawAnalogWrite.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [digitized_analog]
    // Deserialize array length for message field [digitized_analog]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.digitized_analog = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.digitized_analog[i] = DigitizedAnalogWrite.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.digital.forEach((val) => {
      length += DigitalWrite.getMessageSize(val);
    });
    object.raw_analog.forEach((val) => {
      length += RawAnalogWrite.getMessageSize(val);
    });
    object.digitized_analog.forEach((val) => {
      length += DigitizedAnalogWrite.getMessageSize(val);
    });
    return length + 12;
  }

  static datatype() {
    // Returns string type for a service object
    return 'electronic_io_msgs/WriteRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'af7fc4e8b3917015f7b281dfaa23bd85';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # Write a (sub)set of I/O pins (ideally synchronously if supported by the hardware).
    
    DigitalWrite[] digital
    # Analog pins that can be accessed through both "raw" and "digitized" interfaces should each only appear in one of the
    # following fields.
    RawAnalogWrite[] raw_analog
    DigitizedAnalogWrite[] digitized_analog
    
    ================================================================================
    MSG: electronic_io_msgs/DigitalWrite
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # One write request of a digital I/O pin.
    
    string name  # Name of the pin (from SDK, datasheet, package marking etc.)
    bool value  # Requested value of the pin (true = ON, false = OFF).
    bool persist  # If true and the pin has can_persist set to True, try to make the value persistent.
    ================================================================================
    MSG: electronic_io_msgs/RawAnalogWrite
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # One write request of a raw analog I/O pin (working with the represented analog values).
    
    string name  # Name of the pin (from SDK, datasheet, package marking etc.)
    float64 value  # The represented analog value. If possible, it should be in SI units.
    bool persist  # If true and the pin has can_persist set to True, try to make the value persistent.
    ================================================================================
    MSG: electronic_io_msgs/DigitizedAnalogWrite
    # SPDX-License-Identifier: BSD-3-Clause
    # SPDX-FileCopyrightText: Czech Technical University in Prague
    
    # One write request of a digitized analog I/O pin (working with raw ADC values).
    
    string name  # Name of the pin (from SDK, datasheet, package marking etc.)
    int64 value  # The requested ADC value.
    bool persist  # If true and the pin has can_persist set to True, try to make the value persistent.
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new WriteRequest(null);
    if (msg.digital !== undefined) {
      resolved.digital = new Array(msg.digital.length);
      for (let i = 0; i < resolved.digital.length; ++i) {
        resolved.digital[i] = DigitalWrite.Resolve(msg.digital[i]);
      }
    }
    else {
      resolved.digital = []
    }

    if (msg.raw_analog !== undefined) {
      resolved.raw_analog = new Array(msg.raw_analog.length);
      for (let i = 0; i < resolved.raw_analog.length; ++i) {
        resolved.raw_analog[i] = RawAnalogWrite.Resolve(msg.raw_analog[i]);
      }
    }
    else {
      resolved.raw_analog = []
    }

    if (msg.digitized_analog !== undefined) {
      resolved.digitized_analog = new Array(msg.digitized_analog.length);
      for (let i = 0; i < resolved.digitized_analog.length; ++i) {
        resolved.digitized_analog[i] = DigitizedAnalogWrite.Resolve(msg.digitized_analog[i]);
      }
    }
    else {
      resolved.digitized_analog = []
    }

    return resolved;
    }
};

class WriteResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
    }
    else {
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type WriteResponse
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type WriteResponse
    let len;
    let data = new WriteResponse(null);
    return data;
  }

  static getMessageSize(object) {
    return 0;
  }

  static datatype() {
    // Returns string type for a service object
    return 'electronic_io_msgs/WriteResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'd41d8cd98f00b204e9800998ecf8427e';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # If a failure occurs, the service server should throw an exception.
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new WriteResponse(null);
    return resolved;
    }
};

module.exports = {
  Request: WriteRequest,
  Response: WriteResponse,
  md5sum() { return 'af7fc4e8b3917015f7b281dfaa23bd85'; },
  datatype() { return 'electronic_io_msgs/Write'; }
};
